import { ApiExtraOptions } from './interfaces/options.interface';
import { ApiPageRequest } from './interfaces/pages.interface';
import { ApiConfig } from './interfaces/config.interface';
import { HttpClient } from '@angular/common/http';
import { ApiMapper } from './api.mapper';
export declare class Api {
    private _http;
    private _mapper;
    private _config;
    private readonly _baseUrl;
    constructor(_http: HttpClient, _mapper: ApiMapper, _config: ApiConfig);
    page<T = any>(endpoint: string, params?: Partial<ApiPageRequest>, options?: ApiExtraOptions): import("rxjs").Observable<{
        pageSize: number;
        pageNumber: number;
        totalPages: number;
        totalEntries: number;
        data: T[];
    }>;
    get<T = any>(endpoint: string, options?: ApiExtraOptions): import("rxjs").Observable<T>;
    post<T = any>(endpoint: string, body?: any, options?: ApiExtraOptions): Promise<T>;
    put<T = any>(endpoint: string, body?: any, options?: ApiExtraOptions): Promise<T>;
    patch<T = any>(endpoint: string, body?: any, options?: ApiExtraOptions): Promise<T>;
    delete<T = any>(endpoint: string, options?: ApiExtraOptions): Promise<T>;
    private toAbsoluteUrl;
}
