(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/core'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('@bravobit/bb-foundation/api', ['exports', 'rxjs', 'rxjs/operators', '@angular/core', '@angular/common/http'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.bravobit = global.bravobit || {}, global.bravobit['bb-foundation'] = global.bravobit['bb-foundation'] || {}, global.bravobit['bb-foundation'].api = {}), global.rxjs, global.rxjs.operators, global.ng.core, global.ng.common.http));
}(this, (function (exports, rxjs, operators, core, http) { 'use strict';

    var ApiConfig = /** @class */ (function () {
        function ApiConfig() {
        }
        return ApiConfig;
    }());

    var DataSourceRequest = /** @class */ (function () {
        function DataSourceRequest() {
            // Data.
            this._request$ = new rxjs.BehaviorSubject(null);
            this._loading$ = new rxjs.BehaviorSubject(true);
        }
        Object.defineProperty(DataSourceRequest.prototype, "loading", {
            get: function () {
                return this._loading$.asObservable();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataSourceRequest.prototype, "when", {
            get: function () {
                return this._request$.pipe(operators.filter(function (data) { return !!data; }));
            },
            enumerable: false,
            configurable: true
        });
        DataSourceRequest.prototype.startLoading = function () {
            this._loading$.next(true);
        };
        DataSourceRequest.prototype.stopLoading = function () {
            this._loading$.next(false);
        };
        DataSourceRequest.prototype.update = function (params) {
            if (params === void 0) { params = {}; }
            var currentValue = this._request$.getValue();
            // Set the page number to 1 if the query or page size was changed.
            if (currentValue && params && (currentValue.query !== params.query || currentValue.pageSize !== params.pageSize)) {
                params.pageNumber = 1;
            }
            this._request$.next(Object.assign(Object.assign({}, currentValue), params));
        };
        return DataSourceRequest;
    }());
    var ApiDataSource = /** @class */ (function () {
        function ApiDataSource() {
        }
        return ApiDataSource;
    }());

    var ApiMapper = /** @class */ (function () {
        function ApiMapper() {
        }
        ApiMapper.prototype.toPageResponse = function (data) {
            return {
                pageSize: data['page_size'],
                pageNumber: data['page_number'],
                totalPages: data['total_pages'],
                totalEntries: data['total_entries'],
                data: data['data']
            };
        };
        ApiMapper.prototype.toPageRequest = function (data) {
            var params = {};
            params['page'] = "" + (data.pageNumber || 1);
            params['page_size'] = "" + (data.pageSize || 25);
            var sort = (data.sort || [])
                .map(function (_a) {
                var name = _a.name;
                return name;
            })
                .filter(function (name) { return !!name; })
                .join(',');
            var sortDirection = (data.sort || [])
                .map(function (_a) {
                var direction = _a.direction;
                return direction;
            })
                .filter(function (direction) { return !!direction; })
                .join(',');
            if (sort.length > 0 && sortDirection.length > 0) {
                params['sort'] = sort;
                params['sort_direction'] = sortDirection;
            }
            if (data.query && data.query.length > 0 && data.queryFields && data.queryFields.length > 0) {
                params['query'] = data.query;
                params['query_fields'] = data.queryFields.join(',');
            }
            return params;
        };
        return ApiMapper;
    }());
    ApiMapper.decorators = [
        { type: core.Injectable }
    ];

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var Api = /** @class */ (function () {
        function Api(_http, _mapper, _config) {
            this._http = _http;
            this._mapper = _mapper;
            this._config = _config;
            // Validate the config exists.
            if (!this._config) {
                throw new Error('API configuration was not received properly.');
            }
            // Cache the base url.
            this._baseUrl = this._config.baseUrl;
        }
        Api.prototype.page = function (endpoint, params, options) {
            var _this = this;
            if (params === void 0) { params = {}; }
            var _a, _b;
            // Compose the params and headers.
            var pageParams = this._mapper.toPageRequest(params);
            var extraParams = (_a = options === null || options === void 0 ? void 0 : options.params) !== null && _a !== void 0 ? _a : {};
            var extraHeaders = (_b = options === null || options === void 0 ? void 0 : options.headers) !== null && _b !== void 0 ? _b : {};
            // Return an observable so it can be a stream.
            return this.get(endpoint, {
                headers: extraHeaders,
                params: Object.assign(Object.assign({}, pageParams), extraParams)
            }).pipe(operators.map(function (response) { return _this._mapper.toPageResponse(response); }));
        };
        Api.prototype.get = function (endpoint, options) {
            // Add the base url to the endpoint.
            var url = this.toAbsoluteUrl(endpoint);
            // Return an observable so it can be a stream.
            return this._http.get(url, options);
        };
        Api.prototype.post = function (endpoint, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            url = this.toAbsoluteUrl(endpoint);
                            return [4 /*yield*/, this._http.post(url, body, options).toPromise()];
                        case 1: 
                        // Execute the post call as a promise.
                        return [2 /*return*/, _c.sent()];
                    }
                });
            });
        };
        Api.prototype.put = function (endpoint, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            url = this.toAbsoluteUrl(endpoint);
                            return [4 /*yield*/, this._http.put(url, body, options).toPromise()];
                        case 1: 
                        // Execute the put call as a promise.
                        return [2 /*return*/, _c.sent()];
                    }
                });
            });
        };
        Api.prototype.patch = function (endpoint, body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            url = this.toAbsoluteUrl(endpoint);
                            return [4 /*yield*/, this._http.patch(url, body, options).toPromise()];
                        case 1: 
                        // Execute the patch call as a promise.
                        return [2 /*return*/, _c.sent()];
                    }
                });
            });
        };
        Api.prototype.delete = function (endpoint, options) {
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            url = this.toAbsoluteUrl(endpoint);
                            return [4 /*yield*/, this._http.delete(url, options).toPromise()];
                        case 1: 
                        // Execute the delete call as a promise.
                        return [2 /*return*/, _c.sent()];
                    }
                });
            });
        };
        Api.prototype.toAbsoluteUrl = function (endpoint) {
            return "" + this._baseUrl + endpoint;
        };
        return Api;
    }());
    Api.decorators = [
        { type: core.Injectable }
    ];
    Api.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: ApiMapper },
        { type: ApiConfig, decorators: [{ type: core.Optional }] }
    ]; };

    var ApiError = /** @class */ (function () {
        function ApiError(error) {
            var _a, _b, _c;
            this.name = 'ApiError';
            this.message = (_a = error === null || error === void 0 ? void 0 : error.statusText) !== null && _a !== void 0 ? _a : 'Unknown';
            this.status = (_b = error === null || error === void 0 ? void 0 : error.status) !== null && _b !== void 0 ? _b : 200;
            this.raw = (_c = error === null || error === void 0 ? void 0 : error.error) !== null && _c !== void 0 ? _c : {};
        }
        ApiError.prototype.get = function (token, delimiter) {
            if (delimiter === void 0) { delimiter = '.'; }
            var _a;
            var error = (_a = this.raw) !== null && _a !== void 0 ? _a : {};
            return (token !== null && token !== void 0 ? token : '')
                .split(delimiter)
                .reduce(function (previous, token) { return previous && previous[token] ? previous[token] : null; }, error);
        };
        ApiError.prototype.has = function (token, delimiter) {
            if (delimiter === void 0) { delimiter = '.'; }
            return !!this.get(token, delimiter);
        };
        ApiError.prototype.includes = function (token, value) {
            var array = this.get(token);
            return (array !== null && array !== void 0 ? array : []).includes(value);
        };
        return ApiError;
    }());

    var ApiModule = /** @class */ (function () {
        function ApiModule(_parent) {
            if (_parent) {
                throw new Error('ApiModule is already loaded; Import it in the AppModule only.');
            }
        }
        ApiModule.forRoot = function (config) {
            return {
                ngModule: ApiModule,
                providers: [
                    { provide: ApiConfig, useValue: config },
                    Api
                ]
            };
        };
        return ApiModule;
    }());
    ApiModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        http.HttpClientModule
                    ],
                    providers: [
                        { provide: ApiMapper, useClass: ApiMapper }
                    ]
                },] }
    ];
    ApiModule.ctorParameters = function () { return [
        { type: ApiModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
    ]; };

    /**
     * Generated bundle index. Do not edit.
     */

    exports.Api = Api;
    exports.ApiConfig = ApiConfig;
    exports.ApiDataSource = ApiDataSource;
    exports.ApiError = ApiError;
    exports.ApiMapper = ApiMapper;
    exports.ApiModule = ApiModule;
    exports.DataSourceRequest = DataSourceRequest;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bravobit-bb-foundation-api.umd.js.map
