(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs/operators'), require('rxjs'), require('@angular/core'), require('@angular/animations'), require('@bravobit/bb-foundation'), require('@bravobit/bb-foundation/elements'), require('@bravobit/bb-foundation/localize'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@bravobit/bb-foundation/dialog', ['exports', 'rxjs/operators', 'rxjs', '@angular/core', '@angular/animations', '@bravobit/bb-foundation', '@bravobit/bb-foundation/elements', '@bravobit/bb-foundation/localize', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.bravobit = global.bravobit || {}, global.bravobit['bb-foundation'] = global.bravobit['bb-foundation'] || {}, global.bravobit['bb-foundation'].dialog = {}), global.rxjs.operators, global.rxjs, global.ng.core, global.ng.animations, global.bravobit['bb-foundation'], global.bravobit['bb-foundation'].elements, global.bravobit['bb-foundation'].localize, global.ng.common));
}(this, (function (exports, operators, rxjs, core, animations, bbFoundation, elements, localize, common) { 'use strict';

    var BbDialogRef = /** @class */ (function () {
        function BbDialogRef() {
            // Data.
            this._afterClosed$ = new rxjs.Subject();
            this._overlayClicked$ = new rxjs.Subject();
        }
        Object.defineProperty(BbDialogRef.prototype, "afterClosed", {
            get: function () {
                return this._afterClosed$.pipe(operators.take(1));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BbDialogRef.prototype, "overlayClicked", {
            get: function () {
                return this._overlayClicked$.pipe(operators.take(1));
            },
            enumerable: false,
            configurable: true
        });
        BbDialogRef.prototype.onOverlayClicked = function () {
            this._overlayClicked$.next();
        };
        BbDialogRef.prototype.close = function (result) {
            this._afterClosed$.next(result);
        };
        return BbDialogRef;
    }());

    var BbDialogConfig = /** @class */ (function () {
        function BbDialogConfig() {
        }
        return BbDialogConfig;
    }());

    var BbDialogOverlay = /** @class */ (function () {
        function BbDialogOverlay(_elementRef) {
            this._elementRef = _elementRef;
            // Inputs.
            this.animations = true;
            // Outputs.
            this.closeRequested = new core.EventEmitter();
            // State.
            this._state = 'open';
            this._closed$ = new rxjs.Subject();
        }
        Object.defineProperty(BbDialogOverlay.prototype, "state", {
            get: function () {
                return this.animations
                    ? this._state
                    : 'none';
            },
            enumerable: false,
            configurable: true
        });
        BbDialogOverlay.prototype.ngAfterViewInit = function () {
            this.listenForClicks();
        };
        BbDialogOverlay.prototype.ngOnDestroy = function () {
            this._subscription && this._subscription.unsubscribe();
        };
        BbDialogOverlay.prototype.onKeyEvent = function (event) {
            if (event.key === 'Escape') {
                this.closeRequested.emit();
            }
        };
        BbDialogOverlay.prototype.onAnimationDone = function (event) {
            // Check if the dialog is being destroyed.
            if (!['close', 'none'].includes(event.toState)) {
                return;
            }
            this._closed$.next();
            this._closed$.complete();
        };
        BbDialogOverlay.prototype.close = function () {
            this._state = 'close';
            return this._closed$.pipe(operators.take(1)).toPromise();
        };
        BbDialogOverlay.prototype.listenForClicks = function () {
            var _this = this;
            if (!this._elementRef || !this._elementRef.nativeElement) {
                return;
            }
            var mouseDown$ = rxjs.fromEvent(this._elementRef.nativeElement, 'mousedown');
            var touchStart$ = rxjs.fromEvent(this._elementRef.nativeElement, 'touchstart');
            var start$ = rxjs.race([mouseDown$, touchStart$]);
            var mouseUp$ = rxjs.fromEvent(this._elementRef.nativeElement, 'mouseup');
            var touchEnd$ = rxjs.fromEvent(this._elementRef.nativeElement, 'touchend');
            var end$ = rxjs.race([mouseUp$, touchEnd$]);
            this._subscription = start$.pipe(operators.switchMap(function () { return end$; })).subscribe(function () {
                _this.closeRequested.next();
            });
        };
        return BbDialogOverlay;
    }());
    BbDialogOverlay.decorators = [
        { type: core.Component, args: [{
                    selector: 'bb-dialog-overlay',
                    template: "<div class=\"bb-dialog-overlay-backdrop\"></div>\n\n<ng-content select=\"[bb-dialog-modal]\"></ng-content>\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: { 'class': 'bb-dialog-overlay', '[@bbDialogAnimation]': 'state' },
                    animations: [
                        animations.trigger('bbDialogAnimation', [
                            animations.transition('* => none', []),
                            animations.transition(':enter, * => open', [
                                animations.group([
                                    animations.query('.bb-dialog-overlay-backdrop', [
                                        animations.style({ opacity: 0 }),
                                        animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ opacity: 1 }))
                                    ]),
                                    animations.query('.bb-dialog-modal', [
                                        animations.style({ transform: 'scale(0.95)' }),
                                        animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ transform: 'scale(1)' }))
                                    ])
                                ])
                            ]),
                            animations.transition(':leave, * => close', [
                                animations.group([
                                    animations.query('.bb-dialog-overlay-backdrop', [
                                        animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ opacity: 0 }))
                                    ]),
                                    animations.query('.bb-dialog-modal', [
                                        animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ opacity: 0, transform: 'scale(0.95)' }))
                                    ])
                                ])
                            ])
                        ])
                    ],
                    styles: [".bb-dialog-overlay,.bb-dialog-overlay-backdrop{bottom:0;display:flex;flex-direction:column;left:0;position:fixed;right:0;top:0;z-index:1000}.bb-dialog-overlay{padding:20px}.bb-dialog-overlay-backdrop{background-color:rgba(0,0,0,.5)}.bb-dialog-overlay-component{display:block;position:relative;z-index:1001}"]
                },] }
    ];
    BbDialogOverlay.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    BbDialogOverlay.propDecorators = {
        animations: [{ type: core.Input }],
        closeRequested: [{ type: core.Output }],
        onKeyEvent: [{ type: core.HostListener, args: ['window:keyup', ['$event'],] }],
        onAnimationDone: [{ type: core.HostListener, args: ['@bbDialogAnimation.done', ['$event'],] }]
    };

    var BbDialogModal = /** @class */ (function () {
        function BbDialogModal(_patch) {
            this._patch = _patch;
            // Styling.
            this.maxWidth = '420px';
        }
        BbDialogModal.prototype.onOverlayClickedEvent = function (event) {
            event.stopPropagation();
        };
        BbDialogModal.prototype.ngOnInit = function () {
            this._patch.mobileVerticalHeight();
        };
        return BbDialogModal;
    }());
    BbDialogModal.decorators = [
        { type: core.Component, args: [{
                    selector: '[bb-dialog-modal]',
                    template: "<ng-content select=\"[bb-dialog-header]\">\n\n</ng-content>\n\n<div class=\"bb-dialog-modal-body\">\n    <ng-content></ng-content>\n</div>\n\n<ng-content select=\"[bb-dialog-actions]\">\n\n</ng-content>\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: {
                        'class': 'bb-dialog-modal',
                        'role': 'dialog'
                    },
                    styles: [".bb-dialog-modal{background-color:#fff;border-radius:4px;display:flex;flex-direction:column;margin:auto;max-height:calc(var(--vh, 1vh)*100 - 40px);max-width:420px;position:relative;width:100%;z-index:1001}.bb-dialog-modal-body{background-color:#f1f3f6;color:#738694;font-size:13px;line-height:1.4;overflow-y:auto;padding:20px}"]
                },] }
    ];
    BbDialogModal.ctorParameters = function () { return [
        { type: bbFoundation.Patch }
    ]; };
    BbDialogModal.propDecorators = {
        maxWidth: [{ type: core.HostBinding, args: ['style.max-width',] }, { type: core.Input }],
        onOverlayClickedEvent: [{ type: core.HostListener, args: ['click', ['$event'],] }, { type: core.HostListener, args: ['touchstart', ['$event'],] }, { type: core.HostListener, args: ['touchend', ['$event'],] }, { type: core.HostListener, args: ['mouseup', ['$event'],] }, { type: core.HostListener, args: ['mousedown', ['$event'],] }]
    };

    var BbDialogHeader = /** @class */ (function () {
        function BbDialogHeader() {
            // Inputs.
            this.iconName = null;
            this.iconColor = 'black';
            // Outputs.
            this.closeRequested = new core.EventEmitter();
        }
        return BbDialogHeader;
    }());
    BbDialogHeader.decorators = [
        { type: core.Component, args: [{
                    selector: '[bb-dialog-header]',
                    template: "<div class=\"bb-dialog-header-row\">\n    <div *ngIf=\"iconName as icon\"\n         [style.color]=\"iconColor\"\n         class=\"bb-dialog-header-icon\">\n        <i class=\"material-icons\">{{ icon }}</i>\n    </div>\n\n    <div class=\"bb-dialog-header-content\">\n        <ng-content></ng-content>\n    </div>\n\n    <button *ngIf=\"closeRequested?.observers?.length > 0\"\n            (click)=\"closeRequested?.emit()\"\n            type=\"button\"\n            class=\"bb-dialog-header-close\">\n    </button>\n</div>\n\n<nav class=\"bb-dialog-header-navigation\">\n    <ng-content select=\"[bb-dialog-link]\"></ng-content>\n</nav>\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: { 'class': 'bb-dialog-header' },
                    styles: [".bb-dialog-header{background-color:#fff;border-bottom:1px solid #d8d8d8;border-top-left-radius:4px;border-top-right-radius:4px;display:flex;flex-direction:column;justify-content:center;min-height:60px}.bb-dialog-header .bb-dialog-header-content,.bb-dialog-header .bb-dialog-header-content h1{font-size:20px;font-weight:500;max-width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.bb-dialog-header-navigation,.bb-dialog-header-row{align-items:center;display:flex;width:100%}.bb-dialog-header-row{padding:10px 20px}.bb-dialog-header-navigation{overflow-x:auto;padding:0 20px;white-space:nowrap;width:100%}.bb-dialog-header-navigation:empty{height:0;margin:0;padding:0;visibility:hidden}.bb-dialog-header-content{flex:1}.bb-dialog-header-icon{align-items:center;border-radius:50%;display:flex;height:40px;justify-content:center;margin-right:10px;min-height:40px;min-width:40px;overflow:hidden;position:relative;width:40px}.bb-dialog-header-icon:after{background-color:currentColor;bottom:0;content:\"\";left:0;opacity:.14;position:absolute;right:0;top:0}.bb-dialog-header-close{background-color:transparent;border:none;border-radius:4px;display:inline-block;height:32px;margin-left:10px;margin-right:-10px;min-height:32px;min-width:32px;overflow:hidden;position:relative;width:32px}.bb-dialog-header-close:after,.bb-dialog-header-close:before{background-color:#a2a9ba;content:\"\";height:2px;left:20%;margin-top:-1px;position:absolute;top:50%;width:60%}.bb-dialog-header-close:before{transform:rotate(45deg)}.bb-dialog-header-close:after{transform:rotate(-45deg)}.bb-dialog-header-close:hover{background-color:rgba(0,0,0,.08)}.bb-dialog-header-close:focus{background-color:rgba(0,0,0,.12)}.bb-dialog-header-close:active{background-color:rgba(0,0,0,.16)}"]
                },] }
    ];
    BbDialogHeader.propDecorators = {
        iconName: [{ type: core.Input }],
        iconColor: [{ type: core.Input }],
        closeRequested: [{ type: core.Output }]
    };

    var BbDialogLink = /** @class */ (function () {
        function BbDialogLink() {
        }
        return BbDialogLink;
    }());
    BbDialogLink.decorators = [
        { type: core.Component, args: [{
                    selector: '[bb-dialog-link]',
                    template: "<ng-content></ng-content>\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: { 'class': 'bb-dialog-link' },
                    styles: [".bb-dialog-link{align-items:center;background-color:transparent;border-bottom:2px solid transparent;color:#6b5c5c!important;display:flex;font-size:16px;font-weight:500;height:30px;text-decoration:none!important;white-space:nowrap}.bb-dialog-link+.bb-dialog-link{margin-left:10px}.bb-dialog-link:hover:not(.disabled){border-bottom:2px solid rgba(117,119,148,.2)}.bb-dialog-link.active,.bb-dialog-link.active:hover{border-bottom-color:#5b53ff;color:#5b53ff!important}.bb-dialog-link.disabled,.bb-dialog-link.disabled:active,.bb-dialog-link.disabled:focus,.bb-dialog-link.disabled:hover{box-shadow:none;cursor:default;opacity:.4}"]
                },] }
    ];

    var BbDialogActions = /** @class */ (function () {
        function BbDialogActions() {
        }
        return BbDialogActions;
    }());
    BbDialogActions.decorators = [
        { type: core.Component, args: [{
                    selector: '[bb-dialog-actions]',
                    template: "<bb-form-group class=\"end\">\n    <ng-content></ng-content>\n</bb-form-group>\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: { 'class': 'bb-dialog-actions' },
                    styles: [".bb-dialog-actions{background-color:#fff;border-bottom-left-radius:4px;border-bottom-right-radius:4px;border-top:1px solid #d8d8d8;display:block;padding:20px}"]
                },] }
    ];

    var BbDialogInsertion = /** @class */ (function () {
        function BbDialogInsertion(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        return BbDialogInsertion;
    }());
    BbDialogInsertion.decorators = [
        { type: core.Directive, args: [{
                    selector: '[bbDialogInsertion]'
                },] }
    ];
    BbDialogInsertion.ctorParameters = function () { return [
        { type: core.ViewContainerRef }
    ]; };

    var BbDialogContainer = /** @class */ (function () {
        function BbDialogContainer(_elementRef, _changeDetection, _componentFactoryResolver) {
            this._elementRef = _elementRef;
            this._changeDetection = _changeDetection;
            this._componentFactoryResolver = _componentFactoryResolver;
            // Data.
            this.componentRef = null;
            this.childComponentType = null;
            // State.
            this.overlayClicked$ = new rxjs.Subject();
        }
        Object.defineProperty(BbDialogContainer.prototype, "onOverlayClicked", {
            get: function () {
                return this.overlayClicked$.pipe(operators.take(1));
            },
            enumerable: false,
            configurable: true
        });
        BbDialogContainer.prototype.ngAfterViewInit = function () {
            // Load the child component.
            this.loadChildComponent(this.childComponentType);
            // Listen for mouse click on the dialog container.
            this.listenForClicks();
            // Detect changes to notify change detection.
            this._changeDetection.detectChanges();
        };
        BbDialogContainer.prototype.ngOnDestroy = function () {
            this._subscription && this._subscription.unsubscribe();
        };
        BbDialogContainer.prototype.onAnimationDone = function (event) {
            // Check if the dialog is being destroyed.
            if (event.toState !== 'void') {
                return;
            }
            // Destroy the ref if it exists.
            this.componentRef && this.componentRef.destroy();
        };
        BbDialogContainer.prototype.listenForClicks = function () {
            var _this = this;
            if (!this._elementRef || !this._elementRef.nativeElement) {
                return;
            }
            var mouseDown$ = rxjs.fromEvent(this._elementRef.nativeElement, 'mousedown');
            var touchStart$ = rxjs.fromEvent(this._elementRef.nativeElement, 'touchstart');
            var start$ = rxjs.race([mouseDown$, touchStart$]);
            var mouseUp$ = rxjs.fromEvent(this._elementRef.nativeElement, 'mouseup');
            var touchEnd$ = rxjs.fromEvent(this._elementRef.nativeElement, 'touchend');
            var end$ = rxjs.race([mouseUp$, touchEnd$]);
            this._subscription = start$.pipe(operators.switchMap(function () { return end$; })).subscribe(function () {
                _this.overlayClicked$.next();
            });
        };
        BbDialogContainer.prototype.loadChildComponent = function (componentType) {
            // Resolve the component.
            var componentFactory = this._componentFactoryResolver.resolveComponentFactory(componentType);
            // Get the view container ref and clear it.
            var viewContainerRef = this.insertion.viewContainerRef;
            viewContainerRef.clear();
            // Create an instance of the component.
            this.componentRef = viewContainerRef.createComponent(componentFactory);
        };
        return BbDialogContainer;
    }());
    BbDialogContainer.decorators = [
        { type: core.Component, args: [{
                    selector: 'bb-dialog-container',
                    template: "<div class=\"bb-dialog-container-backdrop\">\n</div>\n\n<div class=\"bb-dialog-container-component\">\n    <ng-container bbDialogInsertion>\n    </ng-container>\n</div>\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None,
                    host: { 'class': 'bb-dialog-container', '[@bbDialogAnimation]': 'true' },
                    preserveWhitespaces: false,
                    animations: [
                        animations.trigger('bbDialogAnimation', [
                            animations.transition(':enter', [
                                animations.group([
                                    animations.query('.bb-dialog-container-backdrop', [
                                        animations.style({
                                            opacity: 0
                                        }),
                                        animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                            opacity: 1
                                        }))
                                    ]),
                                    animations.query('.bb-dialog-container-component', [
                                        animations.style({
                                            transform: 'scale(0.95)'
                                        }),
                                        animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                            transform: 'scale(1)'
                                        }))
                                    ])
                                ])
                            ]),
                            animations.transition(':leave', [
                                animations.group([
                                    animations.query('.bb-dialog-container-backdrop', [
                                        animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                            opacity: 0
                                        }))
                                    ]),
                                    animations.query('.bb-dialog-container-component', [
                                        animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                            opacity: 0,
                                            transform: 'scale(0.95)'
                                        }))
                                    ])
                                ])
                            ])
                        ])
                    ],
                    styles: [".bb-dialog-container,.bb-dialog-container-backdrop{bottom:0;left:0;position:fixed;right:0;top:0;z-index:1000}.bb-dialog-container{display:flex}.bb-dialog-container-backdrop{background-color:rgba(0,0,0,.5)}.bb-dialog-container-component{display:block;margin:auto;padding:20px;width:100%;z-index:1001}"]
                },] }
    ];
    BbDialogContainer.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.ChangeDetectorRef },
        { type: core.ComponentFactoryResolver }
    ]; };
    BbDialogContainer.propDecorators = {
        insertion: [{ type: core.ViewChild, args: [BbDialogInsertion, { static: true },] }],
        onAnimationDone: [{ type: core.HostListener, args: ['@bbDialogAnimation.done', ['$event'],] }]
    };

    var nextUniqueId = 0;
    var BbDialogConfirm = /** @class */ (function () {
        function BbDialogConfirm(config, dialogRef) {
            this.config = config;
            this.dialogRef = dialogRef;
            // Id.
            this.dialogId = "bb-dialog-confirm-" + nextUniqueId++;
        }
        BbDialogConfirm.prototype.ngAfterViewInit = function () {
            // Initial focus the button.
            this.confirmButton.focus();
        };
        BbDialogConfirm.prototype.onClose = function (result) {
            this.dialogRef.close(result);
        };
        return BbDialogConfirm;
    }());
    BbDialogConfirm.decorators = [
        { type: core.Component, args: [{
                    selector: 'bb-dialog-confirm',
                    template: "<div [attr.aria-labelledby]=\"dialogId\"\n     bb-dialog-modal\n     bbFocusTrap>\n    <header bb-dialog-header>\n        <h1 *ngIf=\"config?.data?.title as title\"\n            [id]=\"dialogId\">\n            {{ title | bbLocalize:{optional: true} }}\n        </h1>\n    </header>\n\n    <p>\n        {{ config?.data?.description | bbLocalize:{optional: true} }}\n    </p>\n\n    <footer bb-dialog-actions>\n        <button *ngIf=\"config?.data?.cancelButtonText as cancelButtonText\"\n                (click)=\"onClose(false)\"\n                bb-button\n                type=\"button\">\n            {{ cancelButtonText | bbLocalize:{optional: true} }}\n        </button>\n        <button #confirm\n                *ngIf=\"config?.data?.confirmButtonText as confirmButtonText\"\n                (click)=\"onClose(true)\"\n                bb-button\n                type=\"button\"\n                class=\"destructive\">\n            {{ confirmButtonText | bbLocalize:{optional: true} }}\n        </button>\n    </footer>\n</div>\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: { 'class': 'bb-dialog-confirm' },
                    styles: [".bb-dialog-confirm{display:block}"]
                },] }
    ];
    BbDialogConfirm.ctorParameters = function () { return [
        { type: BbDialogConfig },
        { type: BbDialogRef }
    ]; };
    BbDialogConfirm.propDecorators = {
        confirmButton: [{ type: core.ViewChild, args: ['confirm', { read: elements.BbButton },] }]
    };

    var BbDialogInjector = /** @class */ (function () {
        function BbDialogInjector(_parentInjector, _additionalTokens) {
            this._parentInjector = _parentInjector;
            this._additionalTokens = _additionalTokens;
        }
        BbDialogInjector.prototype.get = function (token, notFoundValue) {
            // First check if the additional token
            // contains the token.
            var value = this._additionalTokens.get(token);
            // If that value exists return it.
            if (value) {
                return value;
            }
            // Else query the parent injector.
            return this._parentInjector.get(token, notFoundValue);
        };
        return BbDialogInjector;
    }());

    var Dialog = /** @class */ (function () {
        function Dialog(_injector, _applicationRef, _componentFactoryResolver) {
            this._injector = _injector;
            this._applicationRef = _applicationRef;
            this._componentFactoryResolver = _componentFactoryResolver;
        }
        Dialog.prototype.open = function (componentType, config) {
            return this.createDialog(componentType, config);
        };
        Dialog.prototype.confirm = function (title, description, options) {
            if (options === void 0) { options = {}; }
            return this.open(BbDialogConfirm, {
                data: {
                    title: title,
                    description: description,
                    cancelButtonText: options.cancelButtonText || 'dialog.default_cancel_button',
                    confirmButtonText: options.confirmButtonText || 'dialog.default_confirm_button'
                }
            });
        };
        Dialog.prototype.createDialog = function (componentType, config) {
            var _this = this;
            // Create a reference.
            var dialogRef = new BbDialogRef();
            // Create a map with the config.
            var map = new WeakMap();
            map.set(BbDialogConfig, config);
            map.set(BbDialogRef, dialogRef);
            // Create a custom injector.
            var dialogInjector = new BbDialogInjector(this._injector, map);
            // Resolve the dialog component reference.
            var dialogComponentRef = this._componentFactoryResolver
                .resolveComponentFactory(BbDialogContainer)
                .create(dialogInjector);
            // Attach the host view to the application.
            this._applicationRef.attachView(dialogComponentRef.hostView);
            try {
                // Remove the current focus.
                var activeElement = document.activeElement;
                activeElement.blur();
                // Append the element to the DOM.
                document.body.appendChild(dialogComponentRef.location.nativeElement);
            }
            catch (_a) {
                // Don't do anything, because it must've failed.
            }
            // Set the child component type on the component.
            dialogComponentRef.instance.childComponentType = componentType;
            dialogComponentRef.instance.onOverlayClicked.subscribe(function () { return dialogRef.onOverlayClicked(); });
            // Listen for close events.
            dialogRef.afterClosed.subscribe(function () { return _this.deleteDialog(dialogComponentRef); });
            // Return the reference.
            return dialogRef;
        };
        Dialog.prototype.deleteDialog = function (dialogComponentRef) {
            // Only continue if the dialog component ref exists.
            if (!dialogComponentRef) {
                return;
            }
            // Detach the dialog.
            this._applicationRef.detachView(dialogComponentRef.hostView);
            // Destroy the dialog.
            dialogComponentRef.destroy();
            dialogComponentRef = null;
        };
        return Dialog;
    }());
    Dialog.decorators = [
        { type: core.Injectable }
    ];
    Dialog.ctorParameters = function () { return [
        { type: core.Injector },
        { type: core.ApplicationRef },
        { type: core.ComponentFactoryResolver }
    ]; };

    var DialogModule = /** @class */ (function () {
        function DialogModule() {
        }
        DialogModule.forRoot = function () {
            return {
                ngModule: DialogModule,
                providers: [Dialog]
            };
        };
        return DialogModule;
    }());
    DialogModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        localize.LocalizeModule,
                        elements.ElementsModule
                    ],
                    declarations: [
                        BbDialogContainer,
                        BbDialogOverlay,
                        BbDialogModal,
                        BbDialogHeader,
                        BbDialogLink,
                        BbDialogActions,
                        BbDialogConfirm,
                        BbDialogInsertion
                    ],
                    entryComponents: [
                        BbDialogContainer,
                        BbDialogConfirm
                    ],
                    exports: [
                        BbDialogOverlay,
                        BbDialogModal,
                        BbDialogHeader,
                        BbDialogLink,
                        BbDialogActions
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.BbDialogActions = BbDialogActions;
    exports.BbDialogConfig = BbDialogConfig;
    exports.BbDialogHeader = BbDialogHeader;
    exports.BbDialogLink = BbDialogLink;
    exports.BbDialogModal = BbDialogModal;
    exports.BbDialogOverlay = BbDialogOverlay;
    exports.BbDialogRef = BbDialogRef;
    exports.Dialog = Dialog;
    exports.DialogModule = DialogModule;
    exports.ɵa = BbDialogContainer;
    exports.ɵb = BbDialogInsertion;
    exports.ɵc = BbDialogConfirm;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bravobit-bb-foundation-dialog.umd.js.map
