(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@bravobit/bb-foundation'), require('@angular/common'), require('rxjs'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('@bravobit/bb-foundation/recaptcha', ['exports', '@angular/core', '@bravobit/bb-foundation', '@angular/common', 'rxjs', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.bravobit = global.bravobit || {}, global.bravobit['bb-foundation'] = global.bravobit['bb-foundation'] || {}, global.bravobit['bb-foundation'].recaptcha = {}), global.ng.core, global.bravobit['bb-foundation'], global.ng.common, global.rxjs, global.ng.forms));
}(this, (function (exports, core, bbFoundation, common, rxjs, forms) { 'use strict';

    var RECAPTCHA_CONFIG = new core.InjectionToken('bb-recaptcha-config');

    var RecaptchaLoader = /** @class */ (function () {
        function RecaptchaLoader(_platform, _renderFactory, _document, _config) {
            var _this = this;
            this._platform = _platform;
            this._renderFactory = _renderFactory;
            this._document = _document;
            this._config = _config;
            // Ready state.
            this.ready$ = null;
            // Data.
            this._windowLoadFn = 'bbRecaptchaLoad';
            this._renderer = null;
            // Create a renderer.
            this._renderer = this._renderFactory.createRenderer(null, null);
            // Set the ready subject if not exists.
            if (this.ready$) {
                return;
            }
            this.ready$ = new rxjs.BehaviorSubject(null);
            // Create the script.
            this.createScript(function (captcha) { return _this.ready$.next(captcha); });
        }
        RecaptchaLoader.prototype.createScript = function (callback) {
            var _a;
            // Validate we are on a browser.
            if (!this._platform.isBrowser) {
                return;
            }
            // Create the script.
            var script = this._renderer.createElement('script');
            // Set properties on the script.
            this._renderer.setProperty(script, 'src', this.getUrl());
            this._renderer.setProperty(script, 'async', true);
            this._renderer.setProperty(script, 'defer', true);
            // Set the nonce.
            if (this._config.nonce) {
                this._renderer.setAttribute(script, 'nonce', this._config.nonce);
            }
            // Set the loading function.
            if (this._platform.isBrowser) {
                window[this._windowLoadFn] = function () { return callback(grecaptcha); };
            }
            // Append the script tag.
            this._renderer.appendChild((_a = this._document) === null || _a === void 0 ? void 0 : _a.body, script);
        };
        RecaptchaLoader.prototype.getUrl = function () {
            var _a, _b;
            var baseUrl = (_b = (_a = this._config) === null || _a === void 0 ? void 0 : _a.baseUrl) !== null && _b !== void 0 ? _b : 'https://www.google.com/recaptcha/api.js';
            return [baseUrl, this.getQueryParams()]
                .filter(function (item) { return !!item; })
                .join('?');
        };
        RecaptchaLoader.prototype.getQueryParams = function () {
            var _a, _b;
            var params = {
                render: 'explicit',
                onload: (_a = this._windowLoadFn) !== null && _a !== void 0 ? _a : null,
                hl: (_b = this._config.language) !== null && _b !== void 0 ? _b : null
            };
            return Object.keys(params)
                .map(function (key) { return ({ key: key, value: params[key] }); })
                .filter(function (item) { return !!item.value; })
                .map(function (item) { return (item === null || item === void 0 ? void 0 : item.key) + "=" + (item === null || item === void 0 ? void 0 : item.value); })
                .join('&');
        };
        return RecaptchaLoader;
    }());
    RecaptchaLoader.decorators = [
        { type: core.Injectable }
    ];
    RecaptchaLoader.ctorParameters = function () { return [
        { type: bbFoundation.Platform },
        { type: core.RendererFactory2 },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [common.DOCUMENT,] }] },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [RECAPTCHA_CONFIG,] }] }
    ]; };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var nextUniqueId = 0;
    var BbRecaptchaBase = /** @class */ (function () {
        function BbRecaptchaBase() {
        }
        return BbRecaptchaBase;
    }());
    var BbRecaptchaMixinBase = bbFoundation.mixinGrouped(BbRecaptchaBase);
    var RecaptchaComponent = /** @class */ (function (_super) {
        __extends(RecaptchaComponent, _super);
        function RecaptchaComponent(_zone, _elementRef, _loader, _config) {
            var _this = _super.call(this) || this;
            _this._zone = _zone;
            _this._elementRef = _elementRef;
            _this._loader = _loader;
            _this._config = _config;
            // Host bindings.
            _this.id = "bb-recaptcha-" + nextUniqueId++;
            // Inputs.
            _this.siteKey = null;
            _this.tabIndex = null;
            _this.type = null;
            _this.size = null;
            _this.theme = null;
            _this.badge = null;
            // Outputs.
            _this.resolved = new core.EventEmitter();
            // Data.
            _this._widgetId = null;
            _this._grecaptcha = null;
            _this._executeRequested = false;
            // Form methods.
            _this._onChange = null;
            _this._onTouched = null;
            // Subscriptions.
            _this._subscriptions = new rxjs.Subscription();
            _this.initializeProperties();
            return _this;
        }
        RecaptchaComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            var subscription = this._loader.ready$.subscribe(function (grecaptcha) {
                if (grecaptcha == null || !(grecaptcha.render instanceof Function)) {
                    return;
                }
                _this._grecaptcha = grecaptcha;
                _this.renderCaptchaElement();
            });
            this._subscriptions.add(subscription);
        };
        RecaptchaComponent.prototype.ngOnDestroy = function () {
            var _a;
            // Reset the captcha.
            this.resetCaptchaElement();
            // Unsubscribe of ready data.
            (_a = this._subscriptions) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        };
        RecaptchaComponent.prototype.execute = function () {
            // Check if the captcha is invisible.
            if (this.size !== 'invisible') {
                return;
            }
            // Check if the widget exists else return.
            if (this._widgetId == null) {
                this._executeRequested = true;
                return;
            }
            // Execute the captcha.
            this._grecaptcha.execute(this._widgetId);
        };
        RecaptchaComponent.prototype.reset = function () {
            if (this._widgetId == null) {
                return;
            }
            if (this._grecaptcha.getResponse(this._widgetId)) {
                this.resolved.emit(null);
            }
            this.resetCaptchaElement();
        };
        RecaptchaComponent.prototype.writeValue = function (value) {
            if (value) {
                return;
            }
            this.reset();
        };
        RecaptchaComponent.prototype.registerOnChange = function (fn) {
            this._onChange = fn;
        };
        RecaptchaComponent.prototype.registerOnTouched = function (fn) {
            this._onTouched = fn;
        };
        RecaptchaComponent.prototype.onResolve = function (event) {
            var _a, _b;
            // Emit the value.
            this.resolved.emit(event);
            // Call the form functions.
            (_a = this._onChange) === null || _a === void 0 ? void 0 : _a.call(this, event);
            (_b = this._onTouched) === null || _b === void 0 ? void 0 : _b.call(this);
        };
        RecaptchaComponent.prototype.renderCaptchaElement = function () {
            var _this = this;
            this._widgetId = this._grecaptcha.render(this._elementRef.nativeElement, {
                badge: this.badge,
                sitekey: this.siteKey,
                size: this.size,
                tabindex: this.tabIndex,
                theme: this.theme,
                type: this.type,
                'callback': function (response) { return _this._zone.run(function () { return _this.onResolve(response); }); },
                'expired-callback': function () { return _this._zone.run(function () { return _this.onResolve(null); }); }
            });
            if (this._executeRequested) {
                this._executeRequested = false;
                this.execute();
            }
        };
        RecaptchaComponent.prototype.resetCaptchaElement = function () {
            var _this = this;
            if (this._widgetId == null) {
                return;
            }
            this._zone.runOutsideAngular(function () { return _this._grecaptcha.reset(_this._widgetId); });
        };
        RecaptchaComponent.prototype.initializeProperties = function () {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
            this.siteKey = (_a = this.siteKey) !== null && _a !== void 0 ? _a : (_b = this._config) === null || _b === void 0 ? void 0 : _b.siteKey;
            this.theme = (_c = this.theme) !== null && _c !== void 0 ? _c : (_d = this._config) === null || _d === void 0 ? void 0 : _d.theme;
            this.size = (_e = this.size) !== null && _e !== void 0 ? _e : (_f = this._config) === null || _f === void 0 ? void 0 : _f.size;
            this.type = (_g = this.type) !== null && _g !== void 0 ? _g : (_h = this._config) === null || _h === void 0 ? void 0 : _h.type;
            this.badge = (_j = this.badge) !== null && _j !== void 0 ? _j : (_k = this._config) === null || _k === void 0 ? void 0 : _k.badge;
        };
        return RecaptchaComponent;
    }(BbRecaptchaMixinBase));
    RecaptchaComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'bb-recaptcha',
                    template: "",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None,
                    exportAs: 'bbRecaptcha',
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return RecaptchaComponent; }),
                            multi: true
                        }
                    ],
                    host: {
                        'class': 'bb-recaptcha',
                        '[class.grouped]': 'grouped'
                    },
                    inputs: ['grouped'],
                    preserveWhitespaces: false,
                    styles: [".bb-recaptcha{display:block}.bb-recaptcha.grouped{margin-bottom:20px}"]
                },] }
    ];
    RecaptchaComponent.ctorParameters = function () { return [
        { type: core.NgZone },
        { type: core.ElementRef },
        { type: RecaptchaLoader },
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [RECAPTCHA_CONFIG,] }] }
    ]; };
    RecaptchaComponent.propDecorators = {
        id: [{ type: core.HostBinding, args: ['attr.id',] }, { type: core.Input }],
        siteKey: [{ type: core.Input }],
        tabIndex: [{ type: core.Input }],
        type: [{ type: core.Input }],
        size: [{ type: core.Input }],
        theme: [{ type: core.Input }],
        badge: [{ type: core.Input }],
        resolved: [{ type: core.Output }]
    };

    var RecaptchaModule = /** @class */ (function () {
        function RecaptchaModule() {
        }
        RecaptchaModule.forRoot = function (config) {
            return {
                ngModule: RecaptchaModule,
                providers: [
                    { provide: RECAPTCHA_CONFIG, useValue: config },
                    RecaptchaLoader
                ]
            };
        };
        return RecaptchaModule;
    }());
    RecaptchaModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [RecaptchaComponent],
                    exports: [RecaptchaComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.RECAPTCHA_CONFIG = RECAPTCHA_CONFIG;
    exports.RecaptchaComponent = RecaptchaComponent;
    exports.RecaptchaLoader = RecaptchaLoader;
    exports.RecaptchaModule = RecaptchaModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bravobit-bb-foundation-recaptcha.umd.js.map
