import { CanDisable, CanDisableConstructor, CanHideErrors, CanHideErrorsConstructor, HasError, HasErrorConstructor, IsGrouped, IsGroupedConstructor, IsReadonly, IsReadonlyConstructor, IsRequired, IsRequiredConstructor } from '@bravobit/bb-foundation';
import { EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { ControlValueAccessor, FormControl, FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
declare class BbDatePickerBase {
}
declare const BbFilePickerMixinBase: IsRequiredConstructor & IsReadonlyConstructor & CanDisableConstructor & IsGroupedConstructor & HasErrorConstructor & CanHideErrorsConstructor & typeof BbDatePickerBase;
export declare class BbDatePicker extends BbFilePickerMixinBase implements ControlValueAccessor, OnInit, OnDestroy, IsRequired, IsReadonly, CanDisable, IsGrouped, HasError, CanHideErrors {
    private _localeId;
    readonly _yearRegex: RegExp;
    label: string | TemplateRef<any> | null;
    hint: string | TemplateRef<any> | null;
    dayPlaceholder: string | null;
    monthPlaceholder: string | null;
    yearPlaceholder: string | null;
    form: FormGroup;
    trackByValue: (_: any, item: any) => any;
    data$: Observable<{
        months?: {
            label: string;
            value: number;
        }[];
        days?: {
            label: string;
            value: number;
        }[];
    }>;
    get value(): string | null;
    set value(value: string | null);
    valueChange: EventEmitter<string>;
    private _subscription;
    constructor(_localeId: string);
    ngOnInit(): void;
    ngOnDestroy(): void;
    writeValue(value: string | null): void;
    registerOnChange(method: (_: string | null) => void): void;
    registerOnTouched(method: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    onTouchedCallback: () => void;
    onChangeCallback: (_: string | null) => void;
    onErrorChange(error: {
        token: string;
        data?: any;
    } | null): void;
    validate({ value }: FormControl): {
        invalidDate: boolean;
    };
    private handleChanges;
    private getData;
    private verifyMaxDays;
    private getDayData;
    private getMonthData;
    private composeForm;
    private parseDateStringInForm;
    private parseDateString;
    private formToDateString;
    private getDaysInMonth;
    private isValidDateString;
    private padString;
}
export {};
