import { LocalizeDictionaryParams, LocalizeExtraDictionary } from './interfaces/dictionary.interfaces';
import { StateKey } from '@angular/platform-browser';
import { HttpClient } from '@angular/common/http';
export declare class LocalizeDictionary {
    private readonly _id;
    private readonly _locale;
    private readonly _supportedLanguages;
    private readonly _http;
    readonly stateKey: StateKey<object>;
    private _data;
    private _url;
    constructor({ id, data, locale, supportedLanguages }: LocalizeDictionaryParams, baseUrl: string, http: HttpClient);
    get id(): string;
    get locale(): string;
    get supportedLanguages(): string[];
    get data(): object;
    load(data?: object | null): Promise<boolean>;
    combine(extraDictionary: LocalizeExtraDictionary, mode?: 'prepend' | 'append'): void;
    search(token: string): any;
    private setData;
    private getUrl;
    private isAbsoluteUrl;
    private recursiveSearchValue;
}
