import { LocalizeFunction } from './interfaces/functions.interfaces';
import { LocalizeExtraDictionary } from './interfaces/dictionary.interfaces';
import { LocalizeParams } from './interfaces/options.interfaces';
import { Languages, Platform } from '@bravobit/bb-foundation';
import { LocalizeMissingHandler } from './handlers/missing.handler';
import { LocalizeConfig } from './interfaces/config.interfaces';
import { LocalizeDictionary } from './localize.dictionary';
import { Storage } from '@bravobit/bb-foundation/storage';
import { TransferState } from '@angular/platform-browser';
import { HttpClient } from '@angular/common/http';
export declare class Localize {
    private _http;
    private _storage;
    private _platform;
    private _languages;
    private _state;
    private _config;
    private _missingHandler;
    private _document?;
    private _location?;
    private _baseUrl?;
    private _functions?;
    private _extras?;
    private readonly _dictionaries;
    private readonly _currentDictionary;
    private readonly _functionMiddleware;
    private readonly _storageToken;
    constructor(_http: HttpClient, _storage: Storage, _platform: Platform, _languages: Languages, _state: TransferState, _config: LocalizeConfig, _missingHandler: LocalizeMissingHandler, _document?: any, _location?: any, _baseUrl?: string, _functions?: LocalizeFunction[], _extras?: LocalizeExtraDictionary[]);
    get dictionaries(): LocalizeDictionary[];
    get current(): LocalizeDictionary;
    get locale(): string;
    initialize(): () => Promise<LocalizeDictionary>;
    change(id: string, reload?: boolean): any;
    clear(reload?: boolean): any;
    translate(tokenOrParams: string | LocalizeParams): any;
    private parseInterpolationData;
    private interpolateFunctionData;
    private findReferencesInTranslation;
    private getSubstitutions;
    private retrieveBestMatchingDictionary;
    private getDictionaryFromStorage;
    private getBestBrowserMatchDictionary;
    private convertToParams;
    private load;
    private renderDocumentLanguage;
    private getMatches;
    private reload;
}
