import { ApplicationRef, ComponentFactoryResolver, Injector, TemplateRef } from '@angular/core';
import { Notification, NotificationAction, NotificationsConfig } from './notifications.interfaces';
import { Localize } from '@bravobit/bb-foundation/localize';
import { Platform } from '@bravobit/bb-foundation';
export declare class Notifications {
    private _injector;
    private _platform;
    private _applicationRef;
    private _localize;
    private _config;
    private _componentFactoryResolver;
    private _ref;
    private readonly _defaultMode;
    private readonly _defaultTimeout;
    private readonly _defaultLocalize;
    private readonly _defaultDismiss;
    private readonly _defaultDismissText;
    private readonly _defaultPosition;
    private _notifications$;
    constructor(_injector: Injector, _platform: Platform, _applicationRef: ApplicationRef, _localize: Localize, _config: NotificationsConfig, _componentFactoryResolver: ComponentFactoryResolver);
    success(content: string | TemplateRef<any>, actions?: NotificationAction[], timeout?: number): Notification;
    error(content: string | TemplateRef<any>, actions?: NotificationAction[], timeout?: number): Notification;
    warn(content: string | TemplateRef<any>, actions?: NotificationAction[], timeout?: number): Notification;
    info(content: string | TemplateRef<any>, actions?: NotificationAction[], timeout?: number): Notification;
    create(notification: Notification): Notification;
    private push;
    private pull;
    private compose;
    private createElement;
    private getProperty;
}
