/// <reference types="grecaptcha" />
import { AfterViewInit, ElementRef, EventEmitter, NgZone, OnDestroy } from '@angular/core';
import { IsGroupedConstructor } from '@bravobit/bb-foundation';
import { RecaptchaConfig } from '../recaptcha.interface';
import { ControlValueAccessor } from '@angular/forms';
import { RecaptchaLoader } from '../recaptcha-loader.service';
declare class BbRecaptchaBase {
}
declare const BbRecaptchaMixinBase: IsGroupedConstructor & typeof BbRecaptchaBase;
export declare class RecaptchaComponent extends BbRecaptchaMixinBase implements ControlValueAccessor, AfterViewInit, OnDestroy {
    private _zone;
    private _elementRef;
    private _loader;
    private _config?;
    id: string;
    siteKey: string | null;
    tabIndex: number | null;
    type: ReCaptchaV2.Type | null;
    size: ReCaptchaV2.Size | null;
    theme: ReCaptchaV2.Theme | null;
    badge: ReCaptchaV2.Badge | null;
    resolved: EventEmitter<string>;
    private _widgetId;
    private _grecaptcha;
    private _executeRequested;
    private _onChange;
    private _onTouched;
    private _subscriptions;
    constructor(_zone: NgZone, _elementRef: ElementRef, _loader: RecaptchaLoader, _config?: RecaptchaConfig);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    execute(): void;
    reset(): void;
    writeValue(value: string): void;
    registerOnChange(fn: (value: string) => void): void;
    registerOnTouched(fn: () => void): void;
    onResolve(event: string): void;
    private renderCaptchaElement;
    private resetCaptchaElement;
    private initializeProperties;
}
export {};
